/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package db;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.Driver;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.Properties;
import model.Proizvod;

/**
 *
 * @author student
 */
public class DatabaseBroker {
    Connection connection;
    
    public void uspostaviKonekcijuNaBazuAccess() throws ClassNotFoundException, SQLException{
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        String url="jdbc:odbc:Proizvodi";
        String user="";
        String password="";
        connection=DriverManager.getConnection(url, user, password);
        connection.setAutoCommit(false);
        System.out.println("Uspesna konekcija");
    }
    
    public void uspostaviKonekcijuNaBazuMySQL() throws ClassNotFoundException, SQLException{
        Class.forName("com.mysql.jdbc.Driver");
        String url="jdbc:mysql://localhost:3306/Proizvodi";
        String user="root";
        String password="";
        connection=DriverManager.getConnection(url, user, password);
        connection.setAutoCommit(false);
        System.out.println("Uspesna konekcija");
    }
    
    public void uspostaviKonekcijuNaBazu() throws ClassNotFoundException, SQLException, IOException{
        Class.forName(Util.getInstance().getDriver());
        String url=Util.getInstance().getUrl();
        String user=Util.getInstance().getUser();
        String password=Util.getInstance().getPassword();
        connection=DriverManager.getConnection(url, user, password);
        connection.setAutoCommit(false);
        System.out.println("Uspesna konekcija");
    }
    
    public void uspostaviKonekcijuNaBazuDirektnoPrekoDrivera() throws ClassNotFoundException, SQLException, IOException, InstantiationException, IllegalAccessException{
        Driver driver=(Driver)Class.forName(Util.getInstance().getDriver()).newInstance();
        String url=Util.getInstance().getUrl();
        String user=Util.getInstance().getUser();
        String password=Util.getInstance().getPassword();
        Properties props=new Properties();
        props.put("user", user);
        props.put("password", password);
        connection=driver.connect(url, props);
        connection.setAutoCommit(false);
        System.out.println("Uspesna konekcija");
    }
    
    public void raskiniKonekciju() throws SQLException{
        connection.close();
        System.out.println("Raskinuta konekcija");
    }
    
    public void potvrdiTransakciju() throws SQLException{
        connection.commit();
    }
    
    public void ponistiTransakciju() throws SQLException{
        connection.rollback();
    }
    
    public List<Proizvod> getAllProizvod() throws SQLException{
        List<Proizvod> proizvodi=new ArrayList<>();
        String upit="SELECT proizvodID, naziv, cena FROM proizvod";
        System.out.println(upit);
        Statement statement=connection.createStatement();
        ResultSet rs=statement.executeQuery(upit);
        while(rs.next()){
            Proizvod p=new Proizvod();
            p.setProizvodID(rs.getInt("proizvodID"));
            p.setNaziv(rs.getString("naziv"));
            p.setCena(rs.getDouble("cena"));
            proizvodi.add(p);
        }
        rs.close();
        statement.close();
        
        return proizvodi;
    }
    
    public void insertProizvod(Proizvod proizvod) throws SQLException{
        String upit="INSERT INTO Proizvod (proizvodID, naziv, cena) VALUES ("+proizvod.getProizvodID()+", '"+proizvod.getNaziv()+"',"+proizvod.getCena()+")";
        System.out.println(upit);
        Statement statement=connection.createStatement();
        statement.executeUpdate(upit);
        statement.close();
    }
    
    public void insertProizvodBoljiNacin(Proizvod proizvod) throws SQLException{
        String upit="INSERT INTO Proizvod (proizvodID, naziv, cena) VALUES (?,?,?)";
        System.out.println(upit);
        PreparedStatement statement=connection.prepareStatement(upit);
        statement.setInt(1, proizvod.getProizvodID());
        statement.setString(2, proizvod.getNaziv());
        statement.setDouble(3, proizvod.getCena());
        statement.executeUpdate();
        statement.close();
    }
    
    public void insertListProizvod(List<Proizvod> proizvodi) throws SQLException{
        String upit="INSERT INTO Proizvod (proizvodID, naziv, cena) VALUES (?,?,?)";
        System.out.println(upit);
        PreparedStatement statement=connection.prepareStatement(upit);
        for (Proizvod proizvod : proizvodi) {
            statement.setInt(1, proizvod.getProizvodID());
            statement.setString(2, proizvod.getNaziv());
            statement.setDouble(3, proizvod.getCena());
            statement.executeUpdate();
        }
        statement.close();
    }
    
    //jdbc metadata
    public void vratiTabele() throws SQLException{
        DatabaseMetaData meta=connection.getMetaData();
        ResultSet rs=meta.getTables(null, connection.getSchema(), null, null);
        while(rs.next()){
            String tabela=rs.getString(3);
            System.out.println("META>TABELA> "+tabela);
            vratiKolone(tabela);
        }
        rs.close();
    }
    
    public void vratiKolone(String tabela) throws SQLException{
        DatabaseMetaData meta=connection.getMetaData();
        ResultSet rs=meta.getColumns(connection.getCatalog(), connection.getSchema(), tabela, null);
        while(rs.next()){
            System.out.println("\t>> "+rs.getString(4)+": "+rs.getString(6));
        }
        rs.close();
    }
}
